#include <stdio.h>
#include <stdlib.h>

struct pedrec {int nped, inv, mat, fat, race, sex, orig; char tra[6];};
pedrec *oldped;

int numax,numped=0;

int orif(FILE *fi, FILE *fo) {
    char stri[100];
    int i;
    if (fgets(stri,100,fi)) {
       if (!sscanf(stri,"%i",&numax)) {
	  printf("error reading data from input file\n");
	  return(1);}
       } else {
       printf("error reading input data\n");
       return(1);
       }
    if (!(oldped = (pedrec *) calloc(numax,sizeof(pedrec))))
       {printf("numax=%i; not enough memory. Sorry...",numax);return(1);}
    for (i=0;i<numax;i++)
 
    if (fgets(stri,100,fi)) {
	  if (sscanf(stri,"%i%i%i%i%i%s",&oldped[i].inv,
		      &oldped[i].mat,&oldped[i].fat,&oldped[i].race,
		      &oldped[i].sex,&oldped[i].tra)) {
	      fprintf(fo,"%i,%i,%i,%i\n",oldped[i].inv,
		      oldped[i].mat,oldped[i].fat,
		      oldped[i].sex);
	    } else {
 
	  printf("error reading data from input file\n");
	  return(1);}
       } else {
       printf("error reading input data\n");
       return(1);
       }

    return(NULL);
}


int osdl(FILE *f, int n) {

    char stri[100];
    int i;
    for (i=0;i<n;i++)
    if (!fgets(stri,100,f)) {
       printf("error reading descriptive data\n");
       return(1);
       }
    return(NULL);
}

int main(int narg, char *arg[]) {
    char *infna="pe0.wrk",*outfna="pedigree.sol",stri[100],temp[13];
    FILE *inf,*outf;

    if (narg !=3) {
        printf("USAGE: Sc-ped pedigree outfile\n");
        printf("       pedigree  --- input pedigree file (before \"renum\")\n");
	printf("       outfile --- output pedigree file in SOLAR format\n");
	return(1);
      } else {
	infna=arg[1]; outfna=arg[2];
      }


    if (!(inf=fopen(infna,"r"))) {
       printf("cannot open input data file '%s'\n",infna);
       return(1);
       }
    if (!(outf=fopen(outfna,"w"))) {
       printf("cannot open output data file '%s'\n",outfna);
       return(1);
       }
    if (osdl(inf,1)) return(1);
    fprintf(outf,"id,fa,mo,sex\n");
    if (orif(inf,outf)) return(1);
    fclose(inf);
    fclose(outf);

    return(0);
}

