	program model_genotypes
	parameter (maxmark=100)
	common/locides/lname(maxmark),pos(maxmark),nloci
	character*12 lname
	real pos	
	character*255 form1,form2,form3,temp,pedfile,chrom,map
c,chtfile,gntfile
	integer*1 genotemp(maxmark*2)
	
	map="map.wrk.sol"

	narg=iargc()
	if (narg.lt.1) then
	  print*,'USAGE: Sc-map  mod-map <outmap>'
	  print*,'       mod-map --- file containing genetic map and  
     :allelic frequencies (map file for "modelgty")'
	  print*,'       outmap (optionally) --- genetic map in SOLAR 
     :format'
	  print*,'               if missed, name "map.wrk.sol" used  '
	  stop
	end if
	if (narg.ge.1) call getarg(1,chrom)
	if (narg.ge.2) call getarg(2,map)
	
	open(1,file=chrom)
cchtfile(1:lct))
	do i=1,8
	read(1,'(a255)') temp
	end do
	read(1,'(a255)') form1
	read(1,'(a255)') form2
	read(1,'(a255)') form3
	read(1,'(a255)') temp
	read(1,form1) nloci
c	print *,' number of loci:',nloci
	if (nloci.gt.maxmark) call sstop('too many loci to model.')
	do i=1,nloci
	read(1,form2) lname(i),j,pos(i)
	read(1,'(a255)') temp
	end do
	close(1)
	open(1,file=map)
	write(1,'(i5)') 10
	do i=1,nloci
	if (index(lname(i),'qtl').eq.0) then
	  write(1,'(a12,f9.3)')lname(i),pos(i)
	end if
	end do	
	close(1)
	end
	
	subroutine sstop(a)
	character*255 a
	print *,a
c	open(999,file='err')
c	write(999,'(a255)') a
c	close(999)
	stop
	return
	end