#include <stdio.h>

int main(int narg, char *arg[]) {
 FILE *phef,*racf,*pedf,*outf;
 char *phefn="phtypes.wrk",*pedfn="pe2.wrk",*outfn="phen.sol";
 char stri[30000],stris[255];
 int nd,i,j,k,l,m,n;
 float qt,r0,r1,r2;

    if (narg !=4) {
        printf("USAGE: Sc-phen pedigree phen outfile\n");
        printf("       pedigree  --- input pedigree file (after \"renum\")\n");
        printf("       phen --- phenotypes file (from \"modelpht\")\n");
	printf("       outfile --- output phenotype file in SOLAR format\n");
	return(1);
      } else {
	pedfn=arg[1]; phefn=arg[2]; outfn=arg[3];
      }

 if ((phef=fopen(phefn,"r"))==NULL) {
  printf("error opening file %s\n",phefn);
  return(1);
 }
 if ((pedf=fopen(pedfn,"r"))==NULL) {
  printf("error opening file %s\n",pedfn);
  return(1);
 }
 if ((outf=fopen(outfn,"w"))==NULL) {
  printf("error opening file %s\n",outfn);
  return(1);
 }
 fgets(stri,255,phef);
 sscanf(stri,"%i",&nd);
// printf("%i\n",nd);
 fgets(stri,255,pedf);
 fprintf(outf,"id,QT\n");
 for (i=0;i<nd;i++) {
  fscanf(pedf,"%i %i %i %i %i %i %s",&j,&j,&j,&j,&j,&j,&stris);
  fprintf(outf,"%s,",stris);
  fscanf(phef,"%f",&qt);
  fprintf(outf,"%f\n",qt);
 }
 fclose(outf);
 fclose(pedf);
 fclose(phef);
 return(0);
}
